/*
 *    Copyright 2012 The 99 Software Foundation
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package org.nnsoft.guice.junice.reflection;

import java.lang.annotation.Annotation;
import java.lang.reflect.AnnotatedElement;

/**
 * Interface to specify a generic annotation handler.
 * 
 * @author Simone Tripodi
 * @version $Id: AnnotationHandler.java 245 2010-07-10 19:52:45Z marco.speranza79 $
 */
public interface AnnotationHandler<A extends Annotation, E extends AnnotatedElement> {

    
    /**
     * Invoked when {@link ClassVisitor} found an annotation into a class.
     * 
     * @param annotation that 
     * @param element
     * @throws HandleException
     */
    void handle(A annotation, E element) throws HandleException;

}
